#TEMPLATE(MyTools,'An example ABC compliant class wrapper'),FAMILY('ABC')
#!----------------------------------------------------------------------------------------------------------
#!----------------------------------------------------------------------------------------------------------
#!system keyword allows us to declare template globals
#SYSTEM
#!
#DECLARE(%TplName)
#DECLARE(%TplDescription)
!
#!-----------------------------------------------------------------------------------------------------------
#!-- START OF GROUPS  ---------------------------------------------------------------------------------------
#!-----------------------------------------------------------------------------------------------------------
#GROUP   (%Head)
#IMAGE   ('CWLOGO.ICO'), AT(,,175,26)
#DISPLAY (%TplName),AT(40,3)
#DISPLAY ('This template provides a simple example of'),AT(40,12)
#DISPLAY ('wrapping an ABC compliant class.'),AT(40,22)
#!
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%MakeHead,%xTplName,%xTplDescription)
  #SET (%TplName,%xTplName)
  #SET (%TplDescription,%xTplDescription)
#!
#!-----------------------------------------------------------------------------------------------------------
#GROUP (%ParentCallValid),AUTO
   #IF (~VAREXISTS(%RtVal))
       #DECLARE(%RtVal)
   #ENDIF
   #INSERT (%ParentCallValid(ABC)),%RtVal
   #RETURN %RtVal
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%MyVirtuals, %TreeText, %DataText, %CodeText)
#EMBED(%MyMethodDataSection,'Method Data Section'),%ActiveTemplateInstance,%pClassName,%pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(,%FixClassName(%FixBaseClassToUse('Default'))),TREE(%TreeText & %DataText)
#?%NULL
  #?CODE
  #EMBED(%MyMethodCodeSection,'Method Executable Code Section'),%ActiveTemplateInstance,%pClassName,%pClassMethod,%pClassMethodPrototype,PREPARE(,%FixClassName(%FixBaseClassToUse('Default'))),TREE(%TreeText & %CodeText)
#!-----------------------------------------------------------------------------------------------------------
#!
#!-----------------------------------------------------------------------------------------------------------
#!-- START OF TEMPLATE --------------------------------------------------------------------------------------
#!-----------------------------------------------------------------------------------------------------------
#EXTENSION(List2CSV,'Export listbox contents to CSV file'),PROCEDURE
#BOXED('Default Prompts'),AT(0,0),WHERE(%False),HIDE
  #INSERT(%OOPHiddenPrompts(ABC))
#ENDBOXED
#PREPARE
    #CALL    (%ReadABCFiles(ABC))
    #INSERT  (%MakeHead,'List2CSV','Export listbox contents to CSV file')
    #CALL    (%SetClassDefaults(ABC), 'Default','List2CSV' & %ActiveTemplateInstance,'List2CsvClass')
#ENDPREPARE
#!
#SHEET
#!
  #TAB ('List to CSV')
    #INSERT  (%Head)
    #DISPLAY ()
    #BUTTON     ('Using This Template')
       #INSERT  (%Head)
       #DISPLAY ()
       #BOXED   (' Using This Template ')
          #DISPLAY ()
          #DISPLAY ('Specify a list control in the template prompt.')
          #DISPLAY ('Call the Export2CSV method to send the list''s')
          #DISPLAY ('contents to a CSV file.')
          #DISPLAY ()
          #DISPLAY ('Example:  IF List2CSV1.ExportToCSV() THEN.')
          #DISPLAY ()
       #ENDBOXED
    #ENDBUTTON
    #BUTTON   ('Classes')
      #INSERT (%Head)
      #DISPLAY  ()
      #WITH     (%ClassItem,'Default' )
         #INSERT(%ClassPrompts(ABC))
      #ENDWITH
    #ENDBUTTON
    #DISPLAY ()
    #PROMPT('Select list box: ', from(%Control, %ControlType = 'LIST')),%ListName,REQ
    #!DISPLAY ()
  #ENDTAB
#ENDSHEET
#!
#!
#AT (%BeforeGlobalIncludes),PRIORITY(1)
  #ADD  (%GlobalIncludeList,'LIST2CSV.INC')
#ENDAT
#!
#!
#AT(%GatherObjects)
#CALL(%AddObjectList(ABC), 'Default')
#ENDAT
#!
#!
#AT(%LocalDataClasses)
#INSERT (%GenerateClass(ABC), 'Default')
#ENDAT
#!
#!
#AT(%LocalProcedures)
  #CALL (%GenerateVirtuals(ABC), 'Default', 'Local Objects|MyTools Objects|' & %TplDescription  & '(' & %ThisObjectName & ')','%MyVirtuals(MyTools)')
#ENDAT
#!
#!
#AT(%MyMethodCodeSection,%ActiveTemplateInstance),PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())
  #CALL(%GenerateParentCall(ABC))
#ENDAT
#!
#!
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8020)
#FIX(%Control,%ListName)
%ThisObjectName.Init(%ListName, %ControlFrom)
#ENDAT
#!
#!-----------------------------------------------------------------------------------------------------------
#!-- END OF TEMPLATE ----------------------------------------------------------------------------------------
#!-----------------------------------------------------------------------------------------------------------
