  MEMBER
!------------------------------------------------------------------------------
  INCLUDE('hjSql.INC'), ONCE
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
  MAP
  END
  OMIT('Link MSSQL Driver', LIB_MODE)
    PRAGMA ('link (C%V%MSS%X%%L%.LIB)')
  ! Link MSSQL Driver
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
hjSql.IdentityPrime PROCEDURE !, PROTECTED
sav                  USHORT
tmp                  ANY
sGuid                CSTRING(37)
nBlobs               LONG, AUTO
nBlob                LONG, AUTO
nSize                LONG, AUTO
q                    QUEUE
s                      &STRING
                     END
b                    &BLOB
 CODE
  IF SELF.File{PROP:Type, 1} = 'CSTRING' AND SELF.File{PROP:Name, 1} = 'SYSID'
    ! BLOBs get trampled by SaveFile() and RestoreFile(),
    ! so I've saved them to a queue
    nBlobs = SELF.File{PROP:Blobs}
    IF nBlobs > 0
      FREE(q)
      LOOP nBlob = 1 TO nBlobs
        b &= SELF.File{PROP:Blob, nBlob}
        nSize = b{PROP:Size}
        CLEAR(q)
        q.s &= NEW STRING(nSize)
        IF nSize > 0
          q.s = b[0 : nSize - 1]
        END
        ADD(q)
      END
    END
    sav = SELF.SaveFile()
    SELF.File{PROP:Sql} = 'SELECT newid()'
    NEXT(SELF.File)
    tmp &= WHAT(SELF.Buffer, 1)
    sGuid = tmp
    SELF.RestoreFile(sav)
    ! Now, I need to restore the BLOBs
    IF nBlobs > 0
      LOOP nBlob = 1 TO nBlobs
        GET(q, nBlob)
        b &= SELF.File{PROP:Blob, nBlob}
        nSize = LEN(q.s)
        b{PROP:Size} = nSize
        IF nSize > 0
          b[0 : nSize - 1] = q.s
        END
        DISPOSE(q.s)
      END
    END
    tmp = sGuid
  END
  RETURN

hjSql.Insert PROCEDURE !, BYTE, PROC, VIRTUAL, DERIVED
bRetval              BYTE, AUTO
 CODE
  SELF.IdentityPrime()
  SELF.TimeStamp()
  RETURN PARENT.Insert()

hjSql.PrimeAutoInc PROCEDURE !, BYTE, PROC, VIRTUAL, DERIVED
 CODE
  SELF.IdentityPrime()
  SELF.TimeStamp()
  RETURN PARENT.PrimeAutoInc()

hjSql.TimeStamp PROCEDURE !, PROTECTED
nTimePos             LONG, AUTO
nDatePos             LONG, AUTO
tmp                  ANY
 CODE
  nTimePos = SELF.File{PROP:Fields}
  nDatePos = nTimePos - 1
  IF SELF.File{PROP:Type, nDatePos} = 'DATE' AND SELF.File{PROP:Name, nDatePos} = 'DATEMODIFIED_DATE' AND |
     SELF.File{PROP:Type, nTimePos} = 'TIME' AND SELF.File{PROP:Name, nTimePos} = 'DATEMODIFIED_TIME'
    tmp &= WHAT(SELF.Buffer, nDatePos)
    tmp = TODAY()
    tmp &= WHAT(SELF.Buffer, nTimePos)
    tmp = CLOCK()
  END
  RETURN

hjSql.TryInsert PROCEDURE !, BYTE, PROC, VIRTUAL, DERIVED
bRetval              BYTE, AUTO
 CODE
  SELF.IdentityPrime()
  SELF.TimeStamp()
  RETURN PARENT.TryInsert()

hjSql.TryPrimeAutoInc PROCEDURE !, BYTE, PROC, VIRTUAL, DERIVED
 CODE
  SELF.IdentityPrime()
  SELF.TimeStamp()
  RETURN PARENT.TryPrimeAutoInc()

hjSql.TryUpdate PROCEDURE !, BYTE, PROC, VIRTUAL, DERIVED
 CODE
  SELF.TimeStamp()
  RETURN PARENT.TryUpdate()

hjSql.Update PROCEDURE !, BYTE, PROC, VIRTUAL, DERIVED
 CODE
  SELF.TimeStamp()
  RETURN PARENT.Update()
!------------------------------------------------------------------------------
