
!ABCIncludeFile

OMIT('_EndOfInclude_',_List2CSVSExcelClassPresent_)
_List2CSVSExcelClassPresent_ EQUATE(1)

!--------------------------------------------------------------------------------!
!                                                                                !
! List2CsvClass                                                                  !
!                                                                                !
! Base class to generate CSV file from a list populated using a queue            !
!                                                                                !
! Steve Lewis, Aphelion                                                          !
! slewis@aphelion.net                                                            !
!                                                                                !
! Freely provided to the Clarion community                                       !
! If you make any improvements, please let me know                               !
!                                                                                !
! Version: 1.0, 11/22/2002                                                       !
! Version: 1.1, 05/16/2003                                                       !
!   Changed IncludeColumn method to exclude columns with width of 0              !
! Version: 1.2  04/21/2004                                                       !
!   Add support for handling queue columns not included in list                  !
!                                                                                !
!--------------------------------------------------------------------------------!

List2Csv:MaxLength  EQUATE(255)  !maximum length of field

ExtraFieldQ         QUEUE,TYPE
QColumn               USHORT
Heading               STRING(30)
FormatStr             STRING(20)
Order                 USHORT
                    END
                    
List2CsvClass       CLASS,TYPE,MODULE('LIST2CSV.CLW'),LINK('LIST2CSV.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)
ListQ                 &QUEUE
ExtraFields           &ExtraFieldQ
ListControl           SIGNED
AFileName             STRING(256)

Init                  PROCEDURE(SIGNED ListControl,QUEUE ListQ),VIRTUAL
PromptForFileName     FUNCTION(*STRING FName),BYTE,VIRTUAL
SavedFileName         FUNCTION,STRING,VIRTUAL
GetHeading            FUNCTION(USHORT ColumnNo),STRING,VIRTUAL
GetFieldFormat        FUNCTION(USHORT ColumnNo, USHORT RowNo),STRING,VIRTUAL
GetFieldValue         FUNCTION(USHORT ColumnNo, USHORT RowNo),STRING,VIRTUAL
GetRow                FUNCTION(USHORT RowNo),BYTE,VIRTUAL
IncludeRow            FUNCTION(USHORT RowNo),BYTE,VIRTUAL
IncludeColumn         FUNCTION(USHORT ColumnNo),BYTE,VIRTUAL
Export2CSV            FUNCTION,BYTE,VIRTUAL

AddExtraField         PROCEDURE(USHORT QFieldPos, STRING Heading, STRING FormatStr)
ClearExtraFields      PROCEDURE
Destruct              PROCEDURE,VIRTUAL
                    END !List2CsvClass

_EndOfInclude_
